
From: Philippe Elie <phil.el@wanadoo.fr>

Change the frequency of the local APIC NMI watchdog interrupts from 1000Hz
to 1Hz.  Remove the check_nmi_watchdog() call when using the local apic.


---

 25-akpm/arch/i386/kernel/apic.c |    3 ---
 25-akpm/arch/i386/kernel/nmi.c  |    7 ++-----
 2 files changed, 2 insertions(+), 8 deletions(-)

diff -puN arch/i386/kernel/apic.c~nmi-1-hz arch/i386/kernel/apic.c
--- 25/arch/i386/kernel/apic.c~nmi-1-hz	2004-03-13 22:52:14.695455144 -0800
+++ 25-akpm/arch/i386/kernel/apic.c	2004-03-13 22:52:14.700454384 -0800
@@ -1182,9 +1182,6 @@ int __init APIC_init_uniprocessor (void)
 	phys_cpu_present_map = physid_mask_of_physid(boot_cpu_physical_apicid);
 
 	setup_local_APIC();
-
-	if (nmi_watchdog == NMI_LOCAL_APIC)
-		check_nmi_watchdog();
 #ifdef CONFIG_X86_IO_APIC
 	if (smp_found_config)
 		if (!skip_ioapic_setup && nr_ioapics)
diff -puN arch/i386/kernel/nmi.c~nmi-1-hz arch/i386/kernel/nmi.c
--- 25/arch/i386/kernel/nmi.c~nmi-1-hz	2004-03-13 22:52:14.697454840 -0800
+++ 25-akpm/arch/i386/kernel/nmi.c	2004-03-13 22:52:14.701454232 -0800
@@ -118,11 +118,6 @@ int __init check_nmi_watchdog (void)
 	}
 	printk("OK.\n");
 
-	/* now that we know it works we can reduce NMI frequency to
-	   something more reasonable; makes a difference in some configs */
-	if (nmi_watchdog == NMI_LOCAL_APIC)
-		nmi_hz = 1;
-
 	return 0;
 }
 
@@ -361,6 +356,8 @@ static int setup_p4_watchdog(void)
 
 void setup_apic_nmi_watchdog (void)
 {
+	nmi_hz = 1;
+
 	switch (boot_cpu_data.x86_vendor) {
 	case X86_VENDOR_AMD:
 		if (boot_cpu_data.x86 != 6 && boot_cpu_data.x86 != 15)

_
